/*
 *  flatulent
 *  jesen 2002
 *  iso-8859-2 -> morse code
 *
 *  46 znakov s jedinecnym morseho kodom 
 *  abcdefghijklmnopqrstuvwxyz1234567890?,.;/=-:_!
 *
 *  34 diakritickych znakov
 *
 *  a kopec zbytocnych smernikov 
 *  aby som s nimi vedel co to robit
 *
 */

#include <stdio.h>
// #include "pc.h"

int helmuthovhelp(void);

void delay(unsigned long cas);

int main(int argc, char *argv[])
{
  FILE *zdroj,                        //subor s povodnym textom
       *ciel;                         //subor s morseho kodom

  char *p_a="abcdefghijklmnopqrstuvwxyz1234567890?,.;/=-:_!",
       //win-1250 diakriticke znaky
       *p_diak="奵੹",
       //nediakriticke ekvivalenty
       *p_nodiak="aaaaccddeeiillllnnoorrssttyyuuzzoo",
       tabelator[]=".----.",
       zatvorka[]="-.--.-",
       uvodzovka[]=".-..-.",
       od_pismeno[]="/",              //oddelovac pismen v morse
       zaciatok[]="-.-.-",            //zaciatok vysielania
       *p_zaciatok=NULL,              //nech smernik neukazuje kade tade
       koniec[]="...-.-",             //koniec vysielania
       *p_koniec,
       z_novy,                        //nacitany znak zo suboru zdroj
       *p_z_novy,
       mor[64],                       //meno cieloveho suboru
       *p_mor;
  int  i, j,
       *p_dk,                         //1 pre diakritiku, inak 0
       *p_pip;                        //1 pre pipanie, inak 0

  //pole retazcov s morseho kodom
  char m[][7]={
       ".-","-...","-.-.","-..",".","..-.","--.","....","..",".---","-.-",
       ".-..","--","-.","---",".--.","--.-",".-.","...","-","..-","...-",
       ".--","-..-","-.--","--..",".----","..---","...--","....-",".....",
       "-....","--...","---..","----.","-----","..--..","--..--",".-.-.-",  
       "-.-.-.","-..-.","-...-","-....-","---...","..--.-","--..-"
       };


  //inicializacia smernikov cez adresy nulteho prvku poli premennych
  p_zaciatok=&zaciatok[0];
  p_koniec=&koniec[0];

  p_mor=mor;                          //toto je to iste co horne dva riadky

  
  //inicializacia smernikov cez adresy premennych
  p_z_novy=&z_novy;



  //osetrovacka vstupu
  if (argc==1) { 
    printf("Nezadany nazov vstupneho suboru\nPouzi [am --help]\n");
    return(1);
  }

  if (!strcmp(argv[1],"--help")) {    
    helmuthovhelp();
    return(1);
  }

  //osetrovacka vstupu
  if (argc>5) {                      
    printf("Prilis vela parametrov\nPouzi [am --help]\n");
    return(1);
  }

  //osetrovacka existencie zdrojoveho suboru
  if ((zdroj=fopen(argv[1], "rt"))==NULL) {
    printf("Vstupny subor [%s] neexistuje\nPouzi [(am --help]\n", argv[1]);
    return(1);
  }



  //dynamicke premenne
  p_dk=malloc(2);                     //typ int ma 2 Byty
  p_pip=malloc(2);

  //inicializacia hodnoty int premennych cez smerniky
  *p_dk=0;
  *p_pip=0;



  //vynulovanie retazca
  *p_mor='\0';

  //otvorenie cieloveho suboru
  if (argc>2) {
    if ((strcmp(argv[2],"-d")) && (strcmp(argv[2],"-p"))) {
      ciel=fopen(argv[2], "wt");
        //hodi sa pre otvorenie suboru na pipanie
        for (i=0; *(argv[2]+i); i++)
          *(p_mor+i)=*(argv[2]+i);
        *(p_mor+i)='\0';
    }
    else {
      for (i=0; (*(argv[1]+i) && *(argv[1]+i)!='.'); i++)
        *(p_mor+i)=*(argv[1]+i);        //kopirovanie cez smerniky
      *(p_mor+i)='\0';                  //ukoncenie retazca
      strcat(mor, ".mor");              //pridanie pripony .mor
      ciel=fopen(mor, "wt");
    }
  }
  else {
    for (i=0; (*(argv[1]+i) && *(argv[1]+i)!='.'); i++)
      *(p_mor+i)=*(argv[1]+i);        
    *(p_mor+i)='\0';                  
    strcat(mor, ".mor");              
    ciel=fopen(mor, "wt");
  }
    


  //ci sa bude nodiakritikovat a ci peepat
  for (i=2; i<argc; i++) {
    if (!strcmp(argv[i],"-d")) *p_dk=1;
    if (!strcmp(argv[i],"-p")) *p_pip=1;
  }


  //co ak je vstupny subor prazdny
  if (feof(zdroj)) return(0);


  //zapis uvodu vysielania
  fputs("/// ", ciel);
  for (i=0; *(p_zaciatok+i); i++)
     fputc(*(p_zaciatok+i), ciel);
  fputs(" /// ///", ciel);


  while (!feof(zdroj)) {
    *p_z_novy=fgetc(zdroj);           //nacitanie znaku

    if (*p_dk)                        //odstranenie diakritiky
      for (i=0; *(p_diak+i); i++)
        if (*p_z_novy==*(p_diak+i)) {
          *p_z_novy=*(p_nodiak+i);
          break;
        }

    if (*p_z_novy>='A' && *p_z_novy<='Z')
      *p_z_novy+=('a'-'A');           //downcasnutie znaku velkej abecedy

    switch (*p_z_novy) {
      case '\t' : fputs(tabelator, ciel); fputs(od_pismeno, ciel); break;
      case '('  : fputs(zatvorka, ciel); fputs(od_pismeno, ciel); break;
      case ')'  : fputs(zatvorka, ciel); fputs(od_pismeno, ciel); break;
      case '"'  : fputs(uvodzovka, ciel); fputs(od_pismeno, ciel); break;
      case ' '  : fputs(od_pismeno, ciel); break;
      default   : break;
    }

    for (i=0; *(p_a+i); i++)
      if (z_novy==*(p_a+i)) {
        for (j=0; *(m[i]+j); j++)
          fputc(m[i][j], ciel);
        fputs(od_pismeno, ciel);
        break;
      }

  }


  //zapis zaveru vysielania
  fputs("// /// ", ciel);
  for (i=0; *(p_koniec+i); i++)
     fputc(*(p_koniec+i), ciel);
  fputs(" ///", ciel);


  fclose(zdroj);
  fclose(ciel);


/* pipat nebudeme lebo to neviem v linuxe */

  if (*p_pip) {
    printf("Trpezlivo pocuvaj a vyckaj na vyzvu shellu!\n");
    ciel=fopen(mor, "rt");
    while (!feof(ciel)) {
      *p_z_novy=fgetc(ciel);
      switch (*p_z_novy) {
        case '/' : delay(30000000); break;
        case '.' : printf("\a"); delay(5000000); delay(10000000); break;
        case '-' : printf("\a\a\a\a\a"); delay(25000000); delay(10000000); break;
        default  : break;
      }
    }
    fclose(ciel);
  }

/* a koncim co neviem */
/* a teraz ma napadlo ze nemam rozchodenu zvukovku :-( */


  //uvolnenie dynamickych premennych z pamate
  free(p_dk);
  free(p_pip);

  return(0);
}

void delay(unsigned long cas)
{
  unsigned long i=0;

  for (; i<cas; i++);
}



int helmuthovhelp(void)
{
  printf("\nam - konvertor iso-5589-2 textu do morseho kodu\n\n");
  printf("syntax: am zdroj [ciel] [-d]\n\n");
  printf("           zdroj . . . meno iso-5589-2 textoveho suboru\n");
  printf("           ciel  . . . meno cieloveho suboru (nepovinny parameter,\n");
  printf("                       ak sa nezada, bude morseho kod ulozeny\n");
  printf("                       do suboru s povodnym menom a priponou .mor)\n");
  printf("           -d  . . . . poradi si s diakritikou v zdrojovom subore\n");
  printf("                       (nepovinny parameter)\n\n");
  printf("           -p  . . . . prevedeny text zapipa (nepovinny parameter)\n\n");
  return(1);
}
